'******************************************************************************************************
' Font Encoder Function to encode Data Matrix in OpenOffice.
' High Speed Windows Only Version
'  Copyright 2015 IDAutomation.com, Inc. All rights reserved.
' Tutorial: http://www.idautomation.com/font-encoders/openoffice/
' Required font: IDAutomation2D
'******************************************************************************************************

Private Function EncDM(Optional DataToEncode As String, Optional ProcessTilde As Integer, Optional EncodingMode As Integer, Optional preferredFormat As Integer) As String
   'Set Optional Parameter Defaults, if missing
	If (IsMissing(DataToEncode) Or DataToEncode = "") Then
		DataToEncode = "0" 'Default value in Calc
	end if

	If (IsMissing(ProcessTilde)) Then
		ProcessTilde = 1 
	end if
	
	'If the EncodingMode is not 0-3 then force to the ASCII
	If (IsMissing(EncodingMode)) Then
		EncodingMode = 3
	end if
	
	If EncodingMode > 3 Or EncodingMode < 0 Then
		EncodingMode = 3
	End If

	'Sets the preferred format represented by a number; valid values are from 0 (10X10) to 23 (144X144) and from 24 (8X18) to 29 (16X48)
	'The default value is -1 which sets this to automatic
	If (IsMissing(PreferredFormat)) Then
		PreferredFormat = -1 
	end if
	
	If PreferredFormat > 29 Or PreferredFormat < -1 Then
		PreferredFormat = -1
	End If
	
	oObjFactory = createUnoService( "com.sun.star.bridge.OleObjectFactory" )
	oQRFontEncoder = oObjFactory.createInstance("IDAuto.Datamatrix")
	oQRFontEncoder.FontEncode(DataToEncode, ProcessTilde, EncodingMode, preferredFormat, IDAutomation_DMNative)
	EncDM = DataToEncode
End Function

